﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Windows;
using System.Xml.Serialization;

namespace TreeView_WPF_xml
{
    public class RadTreeViewXmlDataSource : XmlNodeItemList
    {
        private string source;

        public string Source
        {
            get
            {
                return this.source;
            }
            set
            {
                this.source = value;
                AddRange(RetrieveData(Application.GetResourceStream(new Uri(value, UriKind.Relative)).Stream));
            }
        }

        private XmlNodeItemList RetrieveData(Stream xmlStream)
        {
            XmlSerializer serializer = new XmlSerializer(typeof(XmlNodeItemList));
            StreamReader reader = new StreamReader(xmlStream);
            XmlNodeItemList list = (XmlNodeItemList)serializer.Deserialize(reader);
            return list;
        }
    }

    [XmlRoot(ElementName = "Items")]
    public class XmlNodeItemList : ObservableCollection<XmlNodeItem>
    {
        public void AddRange(IEnumerable<XmlNodeItem> range)
        {
            foreach (XmlNodeItem node in range)
            {
                this.Add(node);
            }
        }
    }
}