using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Xml.Serialization;

namespace TreeView_WPF_xml
{
    public class XmlNodeItem : INotifyPropertyChanged
    {
        public XmlNodeItem()
        {
            this.Items = new ObservableCollection<XmlNodeItem>();
        }

        [XmlAttribute(AttributeName = "Header")]
        public string Header { get; set; }
        
        private bool isSelected;

        public event PropertyChangedEventHandler PropertyChanged;

        public bool IsSelected
        {
            get
            {
                return this.isSelected;
            }
            set
            {
                if (this.isSelected != value)
                {
                    this.isSelected = value;
                    MyStaticProperties.SelectedItem = this;
                    this.OnPropertyChanged("IsSelected");
                }
            }
        }
 
        private void OnPropertyChanged(string p)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged.Invoke(this, new PropertyChangedEventArgs(p));
            }
        }

        public ObservableCollection<XmlNodeItem> Items { get; set; }
    }
}